Skip to content

Commit

Permalink
[contrib] Add script to easily create copy-on-write SAN images
Browse files Browse the repository at this point in the history
Signed-off-by: Michael Brown <mcb30@ipxe.org>
  • Loading branch information
mcb30 committed Sep 22, 2010
1 parent 041f01e commit 45d066d
Showing 1 changed file with 48 additions and 0 deletions.
48 changes: 48 additions & 0 deletions contrib/vm/cow
@@ -0,0 +1,48 @@
#!/bin/sh

set -e

imgloop=
tmpfile=
tmploop=
dmname=
cowlink=

function cleanup () {
set +e
[ -n "$cowlink" ] && rm $cowlink
[ -n "$dmname" ] && dmsetup remove $dmname
[ -n "$tmploop" ] && losetup -d $tmploop
[ -n "$tmpfile" ] && rm $tmpfile
[ -n "$imgloop" ] && losetup -d $imgloop
}

trap cleanup EXIT

imgfile=$1
if [ -z "$imgfile" ] ; then
echo Syntax: $0 /path/to/image/file
exit 1
fi

# Set up image loop device
x=`losetup -f` ; losetup -r $x $imgfile ; imgloop=$x

# Create temporary file and set up temporary loop device
tmpfile=`mktemp $imgfile.XXXXXXXXXX`
truncate -r $imgfile $tmpfile
x=`losetup -f` ; losetup $x $tmpfile ; tmploop=$x

# Create snapshot device
imgsize=`blockdev --getsz $imgloop`
x=`basename $imgfile` ; echo 0 $imgsize snapshot $imgloop $tmploop N 16 | \
dmsetup create $x ; dmname=$x
chown --reference=$imgfile /dev/mapper/$dmname
chmod --reference=$imgfile /dev/mapper/$dmname

# Create symlink
x=$imgfile.cow ; ln -s /dev/mapper/$dmname $x ; cowlink=$x

# Wait until killed
echo "Created $cowlink"
while : ; do sleep 2147483647 ; done

0 comments on commit 45d066d

Please sign in to comment.